//========================================================================================
//
//	File:				FWAbout.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================
//
//	ODF Standard About dialog. Credits have 12 lines.
//

#ifndef FWABOUT_H
#define FWABOUT_H

// ----- Framework Includes -----

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWDIALOG_H
#include "FWDialog.h"
#endif

#ifndef FWPSTR_H
#include "FWPStr.h"
#endif

#ifndef FWPRESEN_H
#include "FWPresen.h"
#endif

#ifndef SLGCONST_K
#include "SLGConst.k"
#endif

//========================================================================================
// Forward Class Declarations
//========================================================================================

class FW_CIconShape;

//========================================================================================
// Global Methods 
//========================================================================================

void FW_About(Environment* ev,
			FW_CPart* part,
			FW_ResourceID resourceID);

//========================================================================================
// class FW_CPrivAboutPresentation
//========================================================================================

class FW_CPrivAboutPresentation : public FW_CPresentation
{
public:
	FW_CPrivAboutPresentation(Environment *ev, 
							FW_CPart* thePart, 
							ODTypeToken presentationType,
							FW_ResourceID resourceID);
	virtual ~FW_CPrivAboutPresentation();
	
	virtual FW_CFrame* PrivNewFrame(Environment *ev,
									ODFrame* odFrame, 
									FW_Boolean fromStorage);
private:
	FW_ResourceID 	fAboutID;
};

//========================================================================================
// class FW_CAboutFrame
//========================================================================================

class FW_CAboutFrame : public FW_CDialogFrame
{
public:
	FW_DECLARE_AUTO(FW_CAboutFrame)
	
	FW_CAboutFrame(Environment* ev, 
				ODFrame* odFrame,
				FW_CPresentation* presentation, 
				FW_CPart* part,
				FW_ResourceID resourceID);

	virtual ~FW_CAboutFrame();
	
	// ---- FW_CDialogFrame API -----
	virtual void				HandleNotification(Environment* ev, const FW_CNotification& notification);

	// ----- FW_CFrame API -----
	virtual void 				Draw(Environment *ev, ODFacet* odFacet, ODShape* invalidShape);
	virtual void				CreateSubViews(Environment* ev);
#ifdef FW_BUILD_MAC
	virtual void				FacetAdded(Environment* ev, ODFacet* facet, unsigned short facetCount);
#endif

	virtual FW_Handled			DoAdjustMenus(Environment *ev, FW_CMenuBar* menuBar, 
											FW_Boolean hasMenuFocus, FW_Boolean isRoot);

private:
	FW_CIconShape*		fIconShape;
	
	FW_CString			fPartNameFontName;
	FW_FontStyle		fPartNameFontStyle;
	FW_Fixed			fPartNameFontSize;
	FW_CString			fPartName;
	
	FW_CString			fVersionFontName;
	FW_FontStyle		fVersionFontStyle;
	FW_Fixed			fVersionFontSize;
	FW_CString			fVersion;

	FW_CString			fCreditsFontName;
	FW_FontStyle		fCreditsFontStyle;
	FW_Fixed			fCreditsFontSize;
	FW_CString			fCredits;

	FW_CString			fOKString;
	FW_CPoint			fButtonSize;
};

#endif
