//========================================================================================
//
//	File:				FWInsCmd.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWINSCMD_H
#define FWINSCMD_H

#ifndef FWCMD_H
#include "FWCmd.h"
#endif

#ifndef FWFILESP_H
#include "FWFileSp.h"
#endif

// ----- OpenDoc Includes -----

#ifndef FWODTYPS_H
#include "FWODTyps.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CPart;
class FW_CFrame;
class FW_CEmbeddingFrame;

//========================================================================================
// class FW_CInsertCommand
//========================================================================================

class FW_CInsertCommand : public FW_CCommand
{
public:
	FW_DECLARE_AUTO(FW_CInsertCommand)

//----------------------------------------------------------------------------------------
//	Constructors/Destructor
//
public:
	FW_CInsertCommand(Environment* ev,
					FW_CEmbeddingFrame* frame,
					const FW_PFileSpecification& fileSpec,
					FW_Boolean canUndo);
		// Constructor: undo/redo strings = NULL

	virtual ~FW_CInsertCommand();

//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	// --- Don't override ---
	virtual void 		DoIt(Environment* ev);

//----------------------------------------------------------------------------------------
//	New API
//
public:
	// --- May override, don't call Inherited ---
	virtual void 		PreCommand(Environment* ev);
	virtual void 		CommandDone(Environment* ev);

	virtual FW_Boolean	Insert(Environment* ev);
	
	

//----------------------------------------------------------------------------------------
//	Data Members
//
private:
	FW_PFileSpecification	fFileSpec;
	FW_CEmbeddingFrame*		fEmbeddingFrame;
};

#endif
