//========================================================================================
//
//	File:				FWPrtDef.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRTDEF_H
#define FWPRTDEF_H

//========================================================================================
//	Storage kind
//========================================================================================

typedef short FW_StorageKinds;

const FW_StorageKinds FW_kClipboardStorage 			= 0x0001;
const FW_StorageKinds FW_kDragAndDropStorage 		= 0x0002;
const FW_StorageKinds FW_kLinkStorage				= 0x0004;
const FW_StorageKinds FW_kPartStorage 				= 0x0008;
const FW_StorageKinds FW_kFileStorage 				= 0x0010;

const FW_StorageKinds FW_kDataInterchangeStorage 	= FW_kClipboardStorage | FW_kDragAndDropStorage | FW_kLinkStorage;
const FW_StorageKinds FW_kAllStorage 				= FW_kDataInterchangeStorage | FW_kPartStorage;

//========================================================================================
//	Import/Export support
//========================================================================================

typedef short FW_ImportExport;

const FW_ImportExport FW_kNoImportExport 	= 0x0000;			// No import or export
const FW_ImportExport FW_kImport 			= 0x1000;			// Import is supported
const FW_ImportExport FW_kExportEnabled 	= 0x2000;			// Export is supported
const FW_ImportExport FW_kExportDisabled 	= 0x4000;			// Export is supported but currently disabled

const FW_ImportExport FW_kImportExportEnabled = FW_kImport | FW_kExportEnabled;
const FW_ImportExport FW_kImportExportDisabled = FW_kImport | FW_kExportDisabled;

//========================================================================================
//	Internalize result
//========================================================================================

enum FW_EInternalizeResult
{
	FW_kInternalizeFailed,
	FW_kInternalizeContent,
	FW_kInternalizeFrame,
	FW_kInternalizePart
};

//========================================================================================
//	Start/Stop Drag
//========================================================================================

enum FW_EPrivDraggingFlags
{
	FW_kStartDrag,
	FW_kDragAborted,
	FW_kDragMove,
	FW_kDragCopy
};


#endif

