//========================================================================================
//
//	File:				FWPxyIte.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================
//
//	This file contains the following iterators
//
//		- FW_CProxyProxyFrameIterator
//
//		- FW_CProxyEmbeddedFrameIterator
//

#ifndef FWPXYITE_H
#define FWPXYITE_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

#ifndef FWPART_H
#include "FWPart.h"
#endif

#ifndef FWPROXY_H
#include "FWProxy.h"
#endif

#ifndef FWPXYFRM_H
#include "FWPxyFrm.h"
#endif

#ifndef FWORDCOL_H
#include "FWOrdCol.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODFrame;

//========================================================================================
//	class FW_CProxyProxyFrameIterator
//========================================================================================

class FW_CProxyProxyFrameIterator : public FW_TOrderedCollectionIterator<FW_CProxyFrame>
{
public:
	FW_DECLARE_AUTO(FW_CProxyProxyFrameIterator)

	FW_CProxyProxyFrameIterator(const FW_MProxy* proxy) :
		FW_TOrderedCollectionIterator<FW_CProxyFrame>(proxy->fProxyFrames) {}
	~FW_CProxyProxyFrameIterator() {}
};

//========================================================================================
//	class FW_CProxyEmbeddedFrameIterator
//========================================================================================

class FW_CProxyEmbeddedFrameIterator
{
public:
	FW_DECLARE_AUTO(FW_CProxyEmbeddedFrameIterator)
	
	FW_CProxyEmbeddedFrameIterator(Environment* ev, const FW_MProxy* proxy);
	~FW_CProxyEmbeddedFrameIterator();

	ODFrame*		First(Environment* ev);
	ODFrame*		Next(Environment* ev);
	ODFrame*		Last(Environment* ev);
	ODFrame*		Previous(Environment* ev);
	FW_Boolean		IsNotComplete(Environment*)
						{return fIterator.IsNotComplete();}
							
private:
	ODFrame*		PrivNext(Environment* ev, FW_CProxyFrame* proxyFrame);
	ODFrame*		PrivPrevious(Environment* ev, FW_CProxyFrame* proxyFrame);
								
private:
	FW_CProxyProxyFrameIterator 	fIterator;
	ODFrame*						fCurrentFrame;
};

#endif
