//========================================================================================
//
//	File:				FWSOMIte.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#define SOM_Module_somiter_Source
#include "SOMIter.xih"

#ifndef FWPRTITE_H
#include "FWPrtIte.h"
#endif

#ifndef FWEXCDEF_H
#include "FWExcDef.h"
#endif

#ifndef SOM_Module_OpenDoc_Errors_defined
#include "ErrorDef.xh"
#endif

#define FW_SOMITERATOR(ModuleName, PartName) \
\
/*---------------------------------------------------------------------------------------- \
	somInit \
----------------------------------------------------------------------------------------*/ \
SOM_Scope void  SOMLINK PartName##EmbeddedFramesIteratorsomInit(ModuleName##_##PartName##EmbeddedFramesIterator *somSelf) \
{ \
    ModuleName##_##PartName##EmbeddedFramesIteratorData *somThis = ModuleName##_##PartName##EmbeddedFramesIteratorGetData(somSelf); \
/*    ModuleName##_##PartName##EmbeddedFramesIterator_parent_ODEmbeddedFramesIterator_somInit(somSelf); */\
	somThis->fFrameworkIter = NULL; \
} \
 \
/*---------------------------------------------------------------------------------------- \
	InitIterator \
----------------------------------------------------------------------------------------*/ \
SOM_Scope void  SOMLINK PartName##EmbeddedFramesIteratorInitIterator(ModuleName##_##PartName##EmbeddedFramesIterator *somSelf, Environment *ev, \
		FW_CEmbeddingPart* part, FW_CEmbeddingFrame* frame) \
{ \
    ModuleName##_##PartName##EmbeddedFramesIteratorData *somThis = ModuleName##_##PartName##EmbeddedFramesIteratorGetData(somSelf); \
 \
	FW_TRY \
	{\
		somThis->fFrameworkIter = FW_NEW(FW_CPartEmbeddedFrameIterator, (ev, part, frame)); \
	}\
	FW_CATCH_BEGIN\
	FW_CATCH_REFERENCE(FW_XException, exception)\
	{\
		FW_SetException(ev, exception);\
	}\
	FW_CATCH_EVERYTHING()\
	{\
		FW_SetEvError(ev, kODErrUndefined);\
	}\
	FW_CATCH_END\
} \
 \
/*---------------------------------------------------------------------------------------- \
	somUninit \
----------------------------------------------------------------------------------------*/ \
SOM_Scope void  SOMLINK PartName##EmbeddedFramesIteratorsomUninit(ModuleName##_##PartName##EmbeddedFramesIterator *somSelf) \
{ \
    ModuleName##_##PartName##EmbeddedFramesIteratorData *somThis = ModuleName##_##PartName##EmbeddedFramesIteratorGetData(somSelf); \
 \
 	delete somThis->fFrameworkIter; \
/*   	ModuleName##_##PartName##EmbeddedFramesIterator_parent_ODEmbeddedFramesIterator_somUninit(somSelf); */\
} \
 \
/*---------------------------------------------------------------------------------------- \
	First \
----------------------------------------------------------------------------------------*/ \
SOM_Scope ODFrame*  SOMLINK PartName##EmbeddedFramesIteratorFirst(ModuleName##_##PartName##EmbeddedFramesIterator *somSelf, Environment *ev) \
{ \
    ModuleName##_##PartName##EmbeddedFramesIteratorData *somThis = ModuleName##_##PartName##EmbeddedFramesIteratorGetData(somSelf); \
 \
 	ODFrame* odFrame = NULL;\
 \
	FW_TRY \
	{\
    	odFrame = somThis->fFrameworkIter->First(ev); \
	}\
	FW_CATCH_BEGIN\
	FW_CATCH_REFERENCE(FW_XException, exception)\
	{\
		FW_SetException(ev, exception);\
	}\
	FW_CATCH_EVERYTHING()\
	{\
		FW_SetEvError(ev, kODErrUndefined);\
	}\
	FW_CATCH_END\
\
	return odFrame; \
} \
 \
/*---------------------------------------------------------------------------------------- \
	Next \
----------------------------------------------------------------------------------------*/ \
SOM_Scope ODFrame*  SOMLINK PartName##EmbeddedFramesIteratorNext(ModuleName##_##PartName##EmbeddedFramesIterator *somSelf, Environment *ev) \
{ \
    ModuleName##_##PartName##EmbeddedFramesIteratorData *somThis = ModuleName##_##PartName##EmbeddedFramesIteratorGetData(somSelf); \
 \
 	ODFrame* odFrame = NULL;\
 \
	FW_TRY \
	{\
    	odFrame = somThis->fFrameworkIter->Next(ev); \
	}\
	FW_CATCH_BEGIN\
	FW_CATCH_REFERENCE(FW_XException, exception)\
	{\
		FW_SetException(ev, exception);\
	}\
	FW_CATCH_EVERYTHING()\
	{\
		FW_SetEvError(ev, kODErrUndefined);\
	}\
	FW_CATCH_END\
\
	return odFrame; \
} \
 \
/*---------------------------------------------------------------------------------------- \
	IsNotComplete \
----------------------------------------------------------------------------------------*/ \
SOM_Scope ODBoolean  SOMLINK PartName##EmbeddedFramesIteratorIsNotComplete(ModuleName##_##PartName##EmbeddedFramesIterator *somSelf, Environment *ev) \
{ \
    ModuleName##_##PartName##EmbeddedFramesIteratorData *somThis = ModuleName##_##PartName##EmbeddedFramesIteratorGetData(somSelf); \
 \
 	ODBoolean result = FALSE;\
 \
	FW_TRY \
	{\
    	result = somThis->fFrameworkIter->IsNotComplete(ev); \
	}\
	FW_CATCH_BEGIN\
	FW_CATCH_REFERENCE(FW_XException, exception)\
	{\
		FW_SetException(ev, exception);\
	}\
	FW_CATCH_EVERYTHING()\
	{\
		FW_SetEvError(ev, kODErrUndefined);\
	}\
	FW_CATCH_END\
\
	return result; \
} \
