//========================================================================================
//
//	File:				FWSesion.cpp
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFrameW.hpp"

#ifndef FWSESION_H
#include "FWSesion.h"
#endif

//========================================================================================
//	Static Data Members
//========================================================================================

ODSession* FW_CSession::fgSession = NULL;

//========================================================================================
//	Class FW_CSession
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_CSession::GetODSession
//----------------------------------------------------------------------------------------

ODSession* FW_CSession::GetODSession(Environment* ev)
{
FW_UNUSED(ev);

	FW_ASSERT(fgSession != NULL);
	return fgSession;
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetArbitrator
//----------------------------------------------------------------------------------------

ODArbitrator* FW_CSession::GetArbitrator(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetArbitrator(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetBinding
//----------------------------------------------------------------------------------------

ODBinding* FW_CSession::GetBinding(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetBinding(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetClipboard
//----------------------------------------------------------------------------------------

ODClipboard* FW_CSession::GetClipboard(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetClipboard(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetDispatcher
//----------------------------------------------------------------------------------------

ODDispatcher* FW_CSession::GetDispatcher(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetDispatcher(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetDragAnDrop
//----------------------------------------------------------------------------------------

ODDragAndDrop* FW_CSession::GetDragAndDrop(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetDragAndDrop(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetInfo
//----------------------------------------------------------------------------------------

ODInfo* FW_CSession::GetInfo(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetInfo(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetLinkManager
//----------------------------------------------------------------------------------------

ODLinkManager* FW_CSession::GetLinkManager(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetLinkManager(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetMessageInterface
//----------------------------------------------------------------------------------------

ODMessageInterface* FW_CSession::GetMessageInterface(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetMessageInterface(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetNameResolver
//----------------------------------------------------------------------------------------

ODNameResolver* FW_CSession::GetNameResolver(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetNameResolver(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetNameSpaceManager
//----------------------------------------------------------------------------------------

ODNameSpaceManager* FW_CSession::GetNameSpaceManager(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetNameSpaceManager(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetStorageSystem
//----------------------------------------------------------------------------------------

ODStorageSystem* FW_CSession::GetStorageSystem(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetStorageSystem(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetTranslation
//----------------------------------------------------------------------------------------

ODTranslation* FW_CSession::GetTranslation(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetTranslation(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetUndo
//----------------------------------------------------------------------------------------

ODUndo* FW_CSession::GetUndo(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetUndo(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::GetWindowState
//----------------------------------------------------------------------------------------

ODWindowState* FW_CSession::GetWindowState(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->GetWindowState(ev);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::Tokenize
//----------------------------------------------------------------------------------------

ODTypeToken FW_CSession::Tokenize(Environment* ev, ODType type)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->Tokenize(ev, type);
}

//----------------------------------------------------------------------------------------
//	FW_CSession::UniqueUpdateID
//----------------------------------------------------------------------------------------

ODUpdateID FW_CSession::UniqueUpdateID(Environment* ev)
{
	FW_ASSERT(fgSession != NULL);
	return fgSession->UniqueUpdateID(ev);
}
