//========================================================================================
//
//	File:				FWSesion.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSESION_H
#define FWSESION_H

// ----- OpenDoc Includes -----

#ifndef SOM_ODSession_xh
#include <ODSessn.xh>
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class FW_CPart;

//========================================================================================
// RunTime Info
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment fwpart2
#endif

//========================================================================================
//	class FW_CSession
//========================================================================================

class FW_CSession
{
	friend class FW_CPart;
	
//----------------------------------------------------------------------------------------
//	New API
//
public:
	static ODSession*			GetODSession(Environment* ev);
	static ODArbitrator* 		GetArbitrator(Environment* ev);
	static ODBinding* 			GetBinding(Environment* ev);
	static ODClipboard* 		GetClipboard(Environment* ev);
	static ODDispatcher* 		GetDispatcher(Environment* ev);
	static ODDragAndDrop* 		GetDragAndDrop(Environment* ev);
	static ODInfo* 				GetInfo(Environment* ev);
	static ODLinkManager* 		GetLinkManager(Environment* ev);
	static ODMessageInterface* 	GetMessageInterface(Environment* ev);
	static ODNameResolver* 		GetNameResolver(Environment* ev);
	static ODNameSpaceManager* 	GetNameSpaceManager(Environment* ev);
	static ODStorageSystem* 	GetStorageSystem(Environment* ev);
	static ODTranslation* 		GetTranslation(Environment* ev);
	static ODUndo* 				GetUndo(Environment* ev);
	static ODWindowState* 		GetWindowState(Environment* ev);
	
	static ODTypeToken 			Tokenize(Environment* ev, ODType type);
	static ODUpdateID			UniqueUpdateID(Environment* ev);
	
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
private:
	FW_CSession() {};	// Note that all methods are static

//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
private:
	static ODSession* fgSession;
};

#endif