//========================================================================================
//
//	File:				FWUtil.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWUTIL_H
#define FWUTIL_H

// ----- OpenDoc Includes -----

#ifndef FWODTYPS_H
#include "FWODTyps.h"
#endif

#ifndef SOM_ODRefCntObject_xh
#include <RefCtObj.xh>
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class ODShape;
class ODFrame;

class FW_CFrame;
class FW_CPoint;
class FW_CRect;
class FW_CReadableStream;

//========================================================================================
//	Streams Utilities
//========================================================================================

ODValueType FW_ReadODValueTypeFromStream(Environment* ev, 
								FW_CReadableStream& stream);
ODTypeToken FW_ReadODTypeTokenFromStream(Environment* ev, 
								FW_CReadableStream& stream);

//========================================================================================
//	Clipboard Utilities
//========================================================================================

//========================================================================================
// utilities
//========================================================================================

FW_Boolean FW_IsInLimbo(Environment* ev, ODFrame* frame);

//========================================================================================
//	Coordinate conversion utilities
//========================================================================================

void FW_ContentToFrame(Environment* ev, ODFrame* frame, ODShape* shape);
void FW_FrameToContent(Environment* ev, ODFrame* frame, ODShape* shape);
void FW_ContentToFrame(Environment* ev, ODFrame* frame, FW_CPoint& point);
void FW_FrameToContent(Environment* ev, ODFrame* frame, FW_CPoint& point);
void FW_ContentToFrame(Environment* ev, ODFrame* frame, FW_CRect& rect);
void FW_FrameToContent(Environment* ev, ODFrame* frame, FW_CRect& rect);

void FW_ContentToWindow(Environment* ev, ODFacet* facet, ODShape* shape);
void FW_WindowToContent(Environment* ev, ODFacet* facet, ODShape* shape);
void FW_ContentToWindow(Environment* ev, ODFacet* facet, FW_CPoint& point);
void FW_WindowToContent(Environment* ev, ODFacet* facet, FW_CPoint& point);
void FW_ContentToWindow(Environment* ev, ODFacet* facet, FW_CRect& rect);
void FW_WindowToContent(Environment* ev, ODFacet* facet, FW_CRect& rect);

void FW_FrameToWindow(Environment* ev, ODFacet* facet, ODShape* shape);
void FW_WindowToFrame(Environment* ev, ODFacet* facet, ODShape* shape);
void FW_FrameToWindow(Environment* ev, ODFacet* facet, FW_CPoint& point);
void FW_WindowToFrame(Environment* ev, ODFacet* facet, FW_CPoint& point);
void FW_FrameToWindow(Environment* ev, ODFacet* facet, FW_CRect& rect);
void FW_WindowToFrame(Environment* ev, ODFacet* facet, FW_CRect& rect);

//========================================================================================
//	Global Inline Methods
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_ReleaseODObject
//----------------------------------------------------------------------------------------
inline void FW_ReleaseODObject(Environment* ev, ODRefCntObject* odObject)
{
	if (odObject)
		odObject->Release(ev);
}

#endif
