//========================================================================================
//
//	File:				FWViewAs.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWVIEWAS_H
#define FWVIEWAS_H

#ifndef FWMREFCT_H
#include "FWMRefCt.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class ODFacet;
class ODShape;
struct Environment;

class FW_CFrame;
class FW_CShape;
class FW_CPart;
class FW_CPresentation;
class FW_CGraphicContext;

//========================================================================================
// CLASS FW_CViewAs
//========================================================================================

class FW_CViewAs : public FW_MRefCount
{	
//----------------------------------------------------------------------------------------
//	Constructor(s)/Destructor
//
public:
	FW_CViewAs(Environment *ev, ODTypeToken viewAs);
	virtual ~FW_CViewAs();
	
//----------------------------------------------------------------------------------------
//	New API
//
public:
	virtual void		Load(Environment* ev, FW_CFrame* frame);
	virtual void		Unload(Environment* ev);
	
	virtual ODShape*	AcquireUsedShape(Environment* ev) const;
	
	virtual void		Draw(Environment* ev, 
							FW_CFrame* frame,
							ODFacet* facet, 
							ODShape* invalidShape);
	
	ODTypeToken			GetViewAsToken(Environment*) const
							{return fViewAs;}
	
//----------------------------------------------------------------------------------------
//	Internal API
//
private:
	void				PrivInvalidateUsedShape(Environment*);
	
//----------------------------------------------------------------------------------------
//	Data Members
//
protected:
	FW_CShape*			fShape;
	ODTypeToken			fViewAs;
	FW_CRect			fThumbnailUsedRect;
	ODShape*			fCachedUsedShape;
};

#endif